package dev.shadowsoffire.apotheosis.adventure.affix.augmenting;

import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import java.util.function.Function;
import java.util.Set;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.Apoth;
import java.util.Comparator;
import java.util.Collections;
import java.util.List;
import dev.shadowsoffire.placebo.network.PacketDistro;
import dev.shadowsoffire.apotheosis.Apotheosis;
import java.util.Map;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.HashMap;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import net.minecraft.world.Container;
import net.minecraftforge.items.IItemHandlerModifiable;
import net.minecraftforge.items.wrapper.RecipeWrapper;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import java.util.function.Predicate;
import dev.shadowsoffire.placebo.menu.PlaceboContainerMenu;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.player.Inventory;
import dev.shadowsoffire.placebo.cap.InternalItemHandler;
import net.minecraft.world.entity.player.Player;
import dev.shadowsoffire.placebo.menu.BlockEntityMenu;

public class AugmentingMenu extends BlockEntityMenu<AugmentingTableTile>
{
    public static final int UPGRADE = 0;
    public static final int REROLL = 1;
    public static final int UPGRADE_COST = 2;
    public static final int REROLL_COST = 1;
    protected final Player player;
    protected InternalItemHandler itemInv;
    
    public AugmentingMenu(final int id, final Inventory inv, final BlockPos pos) {
        super((MenuType)Adventure.Menus.AUGMENTING.get(), id, inv, pos);
        this.itemInv = new InternalItemHandler(1);
        this.player = inv.f_35978_;
        this.m_38897_((Slot)new PlaceboContainerMenu.UpdatingSlot(this.itemInv, 0, 16, 16, AffixHelper::hasAffixes) {
            public int m_6641_() {
                return 1;
            }
            
            public int m_5866_(final ItemStack pStack) {
                return 1;
            }
        });
        this.m_38897_((Slot)new PlaceboContainerMenu.UpdatingSlot((PlaceboContainerMenu)this, ((AugmentingTableTile)this.tile).inv, 0, 16, 41, stack -> stack.m_41720_() == Adventure.Items.SIGIL_OF_ENHANCEMENT.get()));
        this.addPlayerSlots(inv, 8, 140);
        this.mover.registerRule((stack, slot) -> slot >= this.playerInvStart && AffixHelper.hasAffixes(stack), 0, 1);
        this.mover.registerRule((stack, slot) -> slot >= this.playerInvStart && stack.m_41720_() == Adventure.Items.SIGIL_OF_ENHANCEMENT.get(), 1, 2);
        this.mover.registerRule((stack, slot) -> slot < this.playerInvStart, this.playerInvStart, this.hotbarStart + 9, true);
        this.registerInvShuffleRules();
    }
    
    public void m_6877_(final Player pPlayer) {
        super.m_6877_(pPlayer);
        this.m_150411_(pPlayer, (Container)new RecipeWrapper((IItemHandlerModifiable)this.itemInv));
    }
    
    public boolean m_6366_(final Player player, final int id) {
        final int selected = id >> 1;
        final ItemStack mainItem = this.getMainItem();
        if (mainItem.m_41619_()) {
            return false;
        }
        final List<AffixInstance> affixes = computeItemAffixes(mainItem);
        if (affixes.isEmpty() || selected >= affixes.size()) {
            return false;
        }
        switch (id & 0x1) {
            case 0: {
                final AffixInstance inst = affixes.get(selected);
                if (inst.level() >= 1.0f) {
                    return false;
                }
                final ItemStack sigils = this.getSigils();
                if (!this.player.m_7500_()) {
                    if (sigils.m_41613_() < 2) {
                        return false;
                    }
                    sigils.m_41774_(2);
                }
                AffixHelper.applyAffix(mainItem, inst.withNewLevel(inst.level() + 0.25f));
                ((Slot)this.f_38839_.get(0)).m_5852_(mainItem);
                player.m_9236_().m_5594_((Player)null, this.pos, SoundEvents.f_11862_, SoundSource.PLAYERS, 1.0f, player.m_9236_().f_46441_.m_188501_() * 0.25f + 1.0f);
                player.m_9236_().m_5594_((Player)null, this.pos, SoundEvents.f_144054_, SoundSource.PLAYERS, 0.34f, player.m_9236_().f_46441_.m_188501_() * 0.2f + 0.8f);
                player.m_9236_().m_5594_((Player)null, this.pos, SoundEvents.f_12471_, SoundSource.PLAYERS, 0.45f, player.m_9236_().f_46441_.m_188501_() * 0.75f + 0.5f);
                return true;
            }
            case 1: {
                final AffixInstance inst = affixes.get(selected);
                final List<DynamicHolder<? extends Affix>> alternatives = computeAlternatives(mainItem, inst, affixes);
                if (alternatives.isEmpty()) {
                    return false;
                }
                final ItemStack sigils2 = this.getSigils();
                if (!this.player.m_7500_()) {
                    if (sigils2.m_41613_() < 1) {
                        return false;
                    }
                    sigils2.m_41774_(1);
                }
                final Map<DynamicHolder<? extends Affix>, AffixInstance> newAffixes = new HashMap<DynamicHolder<? extends Affix>, AffixInstance>(AffixHelper.getAffixes(mainItem));
                newAffixes.remove(inst.affix());
                final DynamicHolder<? extends Affix> newAffix = alternatives.get(player.f_19796_.m_188503_(alternatives.size()));
                newAffixes.put(newAffix, new AffixInstance((DynamicHolder)newAffix, mainItem, inst.rarity(), player.f_19796_.m_188501_()));
                AffixHelper.setAffixes(mainItem, (Map)newAffixes);
                ((Slot)this.f_38839_.get(0)).m_5852_(mainItem);
                player.m_9236_().m_5594_((Player)null, this.pos, SoundEvents.f_11862_, SoundSource.PLAYERS, 1.0f, player.m_9236_().f_46441_.m_188501_() * 0.25f + 1.0f);
                player.m_9236_().m_5594_((Player)null, this.pos, SoundEvents.f_144054_, SoundSource.PLAYERS, 0.34f, player.m_9236_().f_46441_.m_188501_() * 0.2f + 0.8f);
                player.m_9236_().m_5594_((Player)null, this.pos, SoundEvents.f_12471_, SoundSource.PLAYERS, 0.45f, player.m_9236_().f_46441_.m_188501_() * 0.75f + 0.5f);
                this.m_38946_();
                PacketDistro.sendTo(Apotheosis.CHANNEL, (Object)new RerollResultMessage(newAffix), this.player);
                return true;
            }
            default: {
                return false;
            }
        }
    }
    
    public ItemStack getMainItem() {
        return ((Slot)this.f_38839_.get(0)).m_7993_();
    }
    
    public ItemStack getSigils() {
        return ((Slot)this.f_38839_.get(1)).m_7993_();
    }
    
    public static List<AffixInstance> computeItemAffixes(final ItemStack stack) {
        final Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(stack);
        if (affixes.isEmpty()) {
            return Collections.emptyList();
        }
        return affixes.values().stream().sorted(Comparator.comparing(inst -> inst.affix().getId())).filter(a -> !a.affix().equals((Object)Apoth.Affixes.DURABLE)).toList();
    }
    
    protected static List<DynamicHolder<? extends Affix>> computeAlternatives(final ItemStack stack, final AffixInstance selected, final List<AffixInstance> affixes) {
        return LootController.getAvailableAffixes(stack, (LootRarity)selected.rarity().get(), (Set)affixes.stream().map((Function<? super Object, ?>)AffixInstance::affix).collect((Collector<? super Object, ?, Set<? super Object>>)Collectors.toSet()), ((Affix)selected.affix().get()).getType());
    }
}
